var LOGFILE_NAME = "avm-query.log";
var l = new Logger(LOGFILE_NAME);

function GetResponse(challenge,kennwort)
{
	return hex_md5(challenge+"-"+kennwort);
}

function GetChallenge() 
{
	var sURL="http://"+sIP+"/cgi-bin/webcm?getpage=../html/login_sid.xml";
	var h = new HTTP( { 'debug' : 0 }, {});
	var code = h.get(sURL, '');
	if (code.status.valueOf() === 200) {
	    l.logln("getChallenge: " + sURL + ': OK [' + code.status + ']');
	    var sReturn=code.body.substring(code.body.indexOf('<Challenge>') + 11);
	    sReturn=sReturn.substring(0,sReturn.indexOf('</Challenge>'));
	    return sReturn;
	} else {
	    l.logln(sString + ': FAILED! Server replied: "' + code.status + '"');
	    l.logln(code.body);
	}
	return "";
}

function GetSid(challenge,response)
{
	var sURL="http://"+sIP+"/cgi-bin/webcm";
	var sParam="login:command/response=" + challenge + "-" + response + "&getpage=../html/login_sid.xml";
	var h = new HTTP( { 'debug' : 0 }, {});
	var code = h.post(sURL, '', sParam);
	if (code.status.valueOf() === 200) {
	    l.logln("getSID: " + sURL + ': OK [' + code.status + ']');
	    var sReturn=code.body.substring(code.body.indexOf('<SID>') + 5);
	    sReturn=sReturn.substring(0,sReturn.indexOf('</SID>'));
	    sSession=sReturn;
	    return true;
	} else {
	    l.logln(sString + ': FAILED! Server replied: "' + code.status + '"');
	    l.logln(code.body);
	    return false;
	}
}

function makeDots(str) {
	var newStr = "";
	for (var i = 0, len = str.length; i < len; i++) {
		if (str.charCodeAt(i) > 255) newStr += ".";
		else newStr += str.charAt(i);
	}
	return newStr;
}


function login()
{
	getBaseParams();
	if (sIP==null)
		return false;
	if (sIP=="")
		return false;
	if (sPass==null)
		return false;
	if (sPass=="")
		return false;
	var challenge = GetChallenge();
	var resp = challenge + "-" + makeDots(sPass);
	var response=hex_md5(resp);
	return GetSid(challenge, response);
}

function enableCallmonitor()
{
	makeAction({'telcfg:settings/UseClickToDial' : '1'});
	makeAction({'telcfg:command/Dial':'#96*5*'});
	//makeAction({'telcfg:command/Hangup':''});	
}

function disableCallmonitor()
{
	makeAction({'telcfg:settings/UseClickToDial' : '1'});
	makeAction({'telcfg:command/Dial':'#96*4*'});
	//makeAction({'telcfg:command/Hangup':''});	
}
function makeAction(params)
{
	if (sSession=="")
		if (login()==false)
		{
			l.logln("not Login");
			return;
		}
	
	var sURL="http://"+sIP+"/cgi-bin/webcm";
	var sParam="sid=" + sSession;
	for (var sKey in params)
	{
		sParam=sParam+"&" + sKey + "=" + params[sKey];
	}
	
	var h = new HTTP( { 'debug' : 0 }, {});
	var code = h.post(sURL, '', sParam);
	if (code.status.valueOf() === 200) {
	    l.logln("makeAction: "+ sURL + ': OK [' + code.status + ']');
	    return;
	} else {
	    l.logln(sString + ': FAILED! Server replied: "' + code.status + '"');
	    l.logln(code.body);
	    return;
	}
}
function registerHLE(name,comment)
{
	Property.setProperty("/usr/events/" + name + "/name",name);
	Property.setProperty("/usr/events/" + name + "/disabled",false);
	Property.setProperty("/usr/events/" + name + "/comment",comment);
	Property.setProperty("/usr/events/" + name + "/script_id",'avm-connector');
}

function storeParameter(sParameterString)
{
	try
	{	
		// parameter: config/ip config/monitorPort config/enableMonitor config/password
		var oParameterObject=eval("("+unescape(sParameterString)+")");
		if (oParameterObject.ip!=null)
		{			
			Property.setProperty('config/ip', oParameterObject.ip);
			Property.setFlag('config/ip', 'ARCHIVE', true);
		}
		if (oParameterObject.monitorPort!=null)
		{
			Property.setProperty('config/monitorPort', oParameterObject.monitorPort);
			Property.setFlag('config/monitorPort', 'ARCHIVE', true);
		}
		if (oParameterObject.enableMonitor!=null)
		{
			if (oParameterObject.enableMonitor)
				enableCallmonitor();
			else
				disableCallmonitor();
			Property.setProperty('config/enableMonitor', oParameterObject.enableMonitor);
			Property.setFlag('config/enableMonitor', 'ARCHIVE', true);
		}
		if (oParameterObject.password!=null)
		{
			Property.setProperty('config/password', oParameterObject.password);
			Property.setFlag('config/password', 'ARCHIVE', true);
		}
		Property.store();
		var fResult=login();
		var evt = new Event("avm-config-saved",{result:fResult});			
		evt.raise();
	}
	catch(e)
	{
		l.logln("Fehler beim Speichern: " + e);
	}
}

function initOnRunning()
{
	Property.load();
	registerHLE('telefon-ring','Dieses Ereignis wird ausgelst, wenn das Telefon klingelt.');
	registerHLE('telefon-disconnect','Dieses Ereignis wird ausgelst, wenn das Telefon aufgelegt wird.');
	registerHLE('telefon-call','Dieses Ereignis wird ausgelst, wenn ein Anruf gettigt wird.');
	registerHLE('enable-wlan','Dieses Ereignis schaltet das WLAN ein');
	registerHLE('disable-wlan','Dieses Ereignis schaltet das WLAN ab');
	registerHLE('enable-dect','Dieses Ereignis schaltet DECT (Funktelefon) ein');
	registerHLE('disable-dect','Dieses Ereignis schaltet DECT (Funktelefon) aus');	
}

function wlanOn()
{
	makeAction({"wlan:settings/ap_enabled":"1","wlan:settings/ap_enabled_scnd":"1"});
}

function wlanOff()
{
	makeAction({"wlan:settings/ap_enabled":"0","wlan:settings/ap_enabled_scnd":"0"});
}

function dectOn()
{
	makeAction({"dect:settings/enabled":"1"});
}

function dectOff()
{
	makeAction({"dect:settings/enabled":"0"});
}


var sIP=""
var sSession="";
var sPass="";

function getBaseParams()
{
	sIP=Property.getProperty("config/ip");
	sPass=Property.getProperty("config/password");
}
if (raisedEvent.name=="running")
	initOnRunning();
	
if (raisedEvent.name == "avm-config") {
    if (raisedEvent.parameter.actions) {
    	if (raisedEvent.parameter.actions=="test") {
    		var fResult=login();
    		var evt = new Event("avm-config-saved",{result:fResult});			
    		evt.raise();
    	}
		if (raisedEvent.parameter.actions=="wlanOff") {
			wlanOff();
		} 
		if (raisedEvent.parameter.actions=="wlanOn") {
			wlanOn();
		}
		if (raisedEvent.parameter.actions=="dectOn") {
			dectOn();
		}
		if (raisedEvent.parameter.actions=="dectOff") {
			dectOff();
		}
		if (raisedEvent.parameter.actions=="enableMonitor") {
			enableCallmonitor();
		}
		if (raisedEvent.parameter.actions=="disableMonitor") {
			disableCallmonitor();
		}		
		if (raisedEvent.parameter.actions=='save') {
			storeParameter(raisedEvent.parameter.value);
		}		
    }
} else 
	if (raisedEvent.name == 'highlevelevent') {
		if (raisedEvent.parameter.name!=null) {
			switch(raisedEvent.parameter.name)
			{
				case 'enable-wlan':
					wlanOn();
					break;
				case 'disable-wlan':
					wlanOff();
					break;
				case 'enable-dect':
					dectOn();
					break;
				case 'disable-dect':
					dectOff();
					break;
			}
		}				
	}
