var LOGFILE_NAME = "avm-query.log";
var l = new Logger(LOGFILE_NAME);


//////////////////////////////////////////////////////////////
var socket = new TcpSocket();

var ip;
var port;

var sleepTimeMS = 500;

function onConnect(state) {
  if(state) {
	l.logln("Connection successfull");
	Property.setProperty('fConnected',true);
	readLine();
  } else {
    
    if(sleepTimeMS <= 10000) {
        sleepTimeMS *= 2;
      } else 
      	sleepTimeMS = 10000; 

    l.logln("Connection failed, retry in " + (sleepTimeMS/1000) + " sek");
    setTimeout(doConnect, sleepTimeMS);
  }
}



function lineRead(line) {
  l.logln('telefon said: ' + line);
  if (line.indexOf("RING")!=-1)
  {
	  var oArray=line.split(';');
	  l.logln('Raise telefon-ring');
	  var evt = new Event("highlevelevent",{name:'telefon-ring',number:oArray[3]});			
	  evt.raise();
  }
  if (line.indexOf("DISCONNECT")!=-1) 
  {
	  l.logln('Raise telefon-disconnect');
		var evt = new Event("highlevelevent",{name:'telefon-disconnect'});			
		evt.raise();
  }
  if (line.indexOf("CALL")!=-1)
  {	
	  l.logln('Raise telefon-call');
	  var oArray=line.split(';');
	  var evt = new Event("highlevelevent",{name:'telefon-call',number:oArray[5]});			
	  evt.raise();
  }   
  readLine();
}

function readLine() {
  var line = "";
  var doRead = function() {
    socket.receiveLine(1,
      function(data) {
        if(data.length != 0) {
        	lineRead(data);
       } else {
    	 Property.setProperty('fConnected',false);
    	 l.logln('Connection lost');
         doConnect();
       }
      }
    );
  };

  doRead();
}

function doConnect() {
	ip=Property.getNode('config/ip');
	port=Property.getNode('config/monitorPort');
	fDoit=Property.getNode('config/enableMonitor');
	if (fDoit==null) {
		l.logln('Monitor disabled');
		onConnect(false); // no hope yet
	} else		
	if (fDoit==false){
		l.logln('Monitor disabled');
		onConnect(false); // no hope yet
	} else
	if ((ip==null) || (port ==null))
	{
		l.logln('Monitor disabled');
		onConnect(false); // no hope yet
	} else {
		var s_ip=ip.getValue();
		var s_port=port.getValue();
		l.logln("Trying : " + s_ip + " Port " + s_port);
		if ( Property.getProperty('fConnected')) {
			l.logln("ALREADY CONNECTED!");
		} else {
			socket = new TcpSocket();
			socket.connect(s_ip,s_port , onConnect);
		}
	}
}
Property.load();
doConnect();
